﻿using Mall.Common.AOP;
using Mall.Common.Enum.MarketingCenter;
using System;
using System.Collections.Generic;
using System.Text;

namespace Mall.Model.Entity.User
{
    /// <summary>
    /// 会员优惠券实体
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Member_DiscountCoupon

    {
        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 用户id
        /// </summary>
        public int? UserId { get; set; }


        /// <summary>
        /// 描述
        /// </summary>        
        public string Description
        {
            get;
            set;
        }
        /// <summary>
        /// 领取时间
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
        /// <summary>
        /// 商户号id
        /// </summary>        
        public int TenantId
        {
            get;
            set;
        }
        /// <summary>
        /// 小程序id
        /// </summary>        
        public int MallBaseId
        {
            get;
            set;
        }

        /// <summary>
        /// 备注
        /// </summary>
        public string Remarks { get; set; }


        /// <summary>
        /// 平台类型
        /// </summary>
        public PlatformTypeEnum? PlatformType { get; set; }

        /// <summary>
        /// 使用状态 0-未使用，1:已使用，2:已作废
        /// </summary>
        public int UseState { get; set; }

        /// <summary>
        /// 优惠券id
        /// </summary>
        public int CouponId { get; set; }

        /// <summary>
        /// 使用时间
        /// </summary>
        public DateTime? UseDate { get; set; }

        /// <summary>
        /// 订单号
        /// </summary>
        public int OrderId { get; set; }

        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? StartDate { get; set; }



        public DateTime? EndDate { get; set; }


    }
}
